ArgumentException 类

定义

当向方法提供的参数之一无效时引发的异常。The exception that is thrown when one of the arguments provided to a method is not valid.

public ref class ArgumentException : SystemException
[System.Runtime.InteropServices.ComVisible(true)]
[System.Serializable]
public class ArgumentException : SystemException
type ArgumentException = class
    inherit SystemException
    interface ISerializable
Public Class ArgumentException
Inherits SystemException
继承
ArgumentException
派生
属性
实现

示例

下面的示例演示如何引发和捕获ArgumentExceptionThe following example demonstrates how to throw and catch an ArgumentException. 它使用ArgumentException ()。用于显示异常对象的名称的名称属性, 还使用Message属性来显示异常消息的文本。It uses the ArgumentException.GetType().Name property to display the name of the exception object, and also uses the Message property to display the text of the exception message.

using namespace System;

static int DivideByTwo(int num) 
{
    // If num is an odd number, throw an ArgumentException.
    if ((num & 1) == 1)
        throw gcnew ArgumentException(String::Format("{0} is not an even number", num), 
                                      "num");

    // num is even, return half of its value.
    return num / 2;
}

void main() 
{
    // Define some integers for a division operation.
    array<int>^ values = { 10, 7 };
    for each (int value in values) {
        try {
           Console::WriteLine("{0} divided by 2 is {1}", value, DivideByTwo(value));
        }
        catch (ArgumentException^ e) {
           Console::WriteLine("{0}: {1}", e->GetType()->Name, e->Message);
        }
        Console::WriteLine();
    }
}
// This example displays the following output:
//     10 divided by 2 is 5
//     
//     ArgumentException: 7 is not an even number
//     Parameter name: num
using System;

public class Example 
{
    static void Main() 
    {
        // Define some integers for a division operation.
        int[] values = { 10, 7 };
        foreach (var value in values) {
            try {
               Console.WriteLine("{0} divided by 2 is {1}", value, DivideByTwo(value));
            }
            catch (ArgumentException e) {
               Console.WriteLine("{0}: {1}", e.GetType().Name, e.Message);
            }
            Console.WriteLine();
        }
    }

    static int DivideByTwo(int num) 
    {
        // If num is an odd number, throw an ArgumentException.
        if ((num & 1) == 1)
            throw new ArgumentException(String.Format("{0} is not an even number", num), 
                                      "num");

        // num is even, return half of its value.
        return num / 2;
    }
}
// This example displays the following output:
//     10 divided by 2 is 5
//     
//     ArgumentException: 7 is not an even number
//     Parameter name: num
Public Class Example
    Public Shared Sub Main()
        ' Define some integers for a division operation.
        Dim values() As Integer = { 10, 7 }

        For Each value In values
            Try 
               Console.WriteLine("{0} divided by 2 is {1}", value, DivideByTwo(value))
            Catch e As ArgumentException
               Console.WriteLine("{0}: {1}", e.GetType().Name, e.Message)
            End Try
            Console.WriteLine()
        Next
    End Sub
    
    Private Shared Function DivideByTwo(ByVal num As Integer) As Integer
        ' If num is an odd number, throw an ArgumentException.
        If (num And 1) = 1 Then
            Throw New ArgumentException(String.Format("{0} is not an even number", num), 
                                      "num")
        End If
        Return num \ 2
    End Function
End Class
' The example displays the following output:
'     10 divided by 2 is 5
'     
'     ArgumentException: 7 is not an even number
'     Parameter name: num

注解

ArgumentException当调用方法并且传递的自变量中至少有一个参数不符合所调用方法的参数规范时, 将引发。ArgumentException is thrown when a method is invoked and at least one of the passed arguments does not meet the parameter specification of the called method. ParamName属性标识无效参数。The ParamName property identifies the invalid argument.

通常情况下, ArgumentException由公共语言运行时或其他类库引发, 并指示开发人员错误。Most commonly, an ArgumentException is thrown by the common language runtime or another class library and indicates developer error. 如果ArgumentException从代码引发, 则应确保异常的Message属性包含有意义的错误消息, 该消息描述了参数的无效参数和所需的值范围。If you throw an ArgumentException from your code, you should ensure that the exception's Message property includes a meaningful error message that describes the invalid argument and the expected range of values for the argument.

的主要派生类ArgumentExceptionArgumentNullExceptionArgumentOutOfRangeExceptionThe primary derived classes of ArgumentException are ArgumentNullException and ArgumentOutOfRangeException. 应使用这些派生类ArgumentException, 而不是使用这些派生类, 但这些派生类都不是可接受的。These derived classes should be used instead of ArgumentException, except in situations where neither of the derived classes is acceptable. 例如, 异常应由引发:For example, exceptions should be thrown by:

如果方法调用没有任何自变量, 或者失败不涉及自变量本身, 则InvalidOperationException应使用。If the method call does not have any argument or if the failure does not involve the arguments themselves, then InvalidOperationException should be used.

ArgumentException使用 COR_E_ARGUMENT 值为0x80070057 的 HRESULT。ArgumentException uses the HRESULT COR_E_ARGUMENT, which has the value 0x80070057.

有关实例的初始属性值的列表ArgumentException,请参阅ArgumentException构造函数。For a list of initial property values for an instance of ArgumentException, see the ArgumentException constructors.

构造函数

ArgumentException()

初始化 ArgumentException 类的新实例。Initializes a new instance of the ArgumentException class.

ArgumentException(SerializationInfo, StreamingContext)

用序列化数据初始化 ArgumentException 类的新实例。Initializes a new instance of the ArgumentException class with serialized data.

ArgumentException(String)

用指定的错误消息初始化 ArgumentException 类的新实例。Initializes a new instance of the ArgumentException class with a specified error message.

ArgumentException(String, Exception)

使用指定的错误消息和对作为此异常原因的内部异常的引用来初始化 ArgumentException 类的新实例。Initializes a new instance of the ArgumentException class with a specified error message and a reference to the inner exception that is the cause of this exception.

ArgumentException(String, String)

使用指定的错误消息和导致此异常的参数的名称来初始化 ArgumentException 类的新实例。Initializes a new instance of the ArgumentException class with a specified error message and the name of the parameter that causes this exception.

ArgumentException(String, String, Exception)

使用指定的错误消息、参数名称和对内部异常的引用(为该异常根源)来初始化 ArgumentException 类的新实例。Initializes a new instance of the ArgumentException class with a specified error message, the parameter name, and a reference to the inner exception that is the cause of this exception.

属性

Data

获取提供有关异常的其他用户定义信息的键/值对集合。Gets a collection of key/value pairs that provide additional user-defined information about the exception.

(继承自 Exception)
HelpLink

获取或设置指向与此异常关联的帮助文件链接。Gets or sets a link to the help file associated with this exception.

(继承自 Exception)
HResult

获取或设置 HRESULT(一个分配给特定异常的编码数字值)。Gets or sets HRESULT, a coded numerical value that is assigned to a specific exception.

(继承自 Exception)
InnerException

获取导致当前异常的 Exception 实例。Gets the Exception instance that caused the current exception.

(继承自 Exception)
Message

获取错误消息和参数名;如果未设置参数名,则仅获取错误消息。Gets the error message and the parameter name, or only the error message if no parameter name is set.

ParamName

获取导致该异常的参数的名称。Gets the name of the parameter that causes this exception.

Source

获取或设置导致错误的应用程序或对象的名称。Gets or sets the name of the application or the object that causes the error.

(继承自 Exception)
StackTrace

获取调用堆栈上的即时框架字符串表示形式。Gets a string representation of the immediate frames on the call stack.

(继承自 Exception)
TargetSite

获取引发当前异常的方法。Gets the method that throws the current exception.

(继承自 Exception)

方法

Equals(Object)

确定指定的对象是否等于当前对象。Determines whether the specified object is equal to the current object.

(继承自 Object)
GetBaseException()

当在派生类中重写时,返回 Exception,它是一个或多个并发的异常的根源。When overridden in a derived class, returns the Exception that is the root cause of one or more subsequent exceptions.

(继承自 Exception)
GetHashCode()

作为默认哈希函数。Serves as the default hash function.

(继承自 Object)
GetObjectData(SerializationInfo, StreamingContext)

设置带有参数名和附加异常信息的 SerializationInfo 对象。Sets the SerializationInfo object with the parameter name and additional exception information.

GetType()

获取当前实例的运行时类型。Gets the runtime type of the current instance.

(继承自 Exception)
MemberwiseClone()

创建当前 Object 的浅表副本。Creates a shallow copy of the current Object.

(继承自 Object)
ToString()

创建并返回当前异常的字符串表示形式。Creates and returns a string representation of the current exception.

(继承自 Exception)

事件

SerializeObjectState

当异常被序列化用来创建包含有关该异常的徐列出数据的异常状态对象时会出现该问题。Occurs when an exception is serialized to create an exception state object that contains serialized data about the exception.

(继承自 Exception)

适用于

另请参阅